Index: trunk/ICeCoffEE/ICeCoffEE/ICeCoffEE.xcodeproj/nicholas.mode2
===================================================================
--- trunk/ICeCoffEE/ICeCoffEE/ICeCoffEE.xcodeproj/nicholas.mode2	(revision 216)
+++ trunk/ICeCoffEE/ICeCoffEE/ICeCoffEE.xcodeproj/nicholas.mode2	(revision 256)
@@ -186,5 +186,212 @@
 	<array/>
 	<key>OpenEditors</key>
-	<array/>
+	<array>
+		<dict>
+			<key>Content</key>
+			<dict>
+				<key>PBXProjectModuleGUID</key>
+				<string>E16950D60A6DA4970085C106</string>
+				<key>PBXProjectModuleLabel</key>
+				<string>ui.plist</string>
+				<key>PBXSplitModuleInNavigatorKey</key>
+				<dict>
+					<key>Split0</key>
+					<dict>
+						<key>PBXProjectModuleGUID</key>
+						<string>E16950D70A6DA4970085C106</string>
+						<key>PBXProjectModuleLabel</key>
+						<string>ui.plist</string>
+						<key>_historyCapacity</key>
+						<integer>0</integer>
+						<key>bookmark</key>
+						<string>E169513B0A6DAEBC0085C106</string>
+						<key>history</key>
+						<array>
+							<string>E16950D80A6DA4970085C106</string>
+						</array>
+					</dict>
+					<key>SplitCount</key>
+					<string>1</string>
+				</dict>
+				<key>StatusBarVisibility</key>
+				<true/>
+			</dict>
+			<key>Geometry</key>
+			<dict>
+				<key>Frame</key>
+				<string>{{0, 20}, {793, 1001}}</string>
+				<key>PBXModuleWindowStatusBarHidden2</key>
+				<false/>
+				<key>RubberWindowFrame</key>
+				<string>38 110 793 1042 0 0 1920 1178 </string>
+			</dict>
+		</dict>
+		<dict>
+			<key>Content</key>
+			<dict>
+				<key>PBXProjectModuleGUID</key>
+				<string>E169512A0A6DAD600085C106</string>
+				<key>PBXProjectModuleLabel</key>
+				<string>ICeCoffEETrigger.m</string>
+				<key>PBXSplitModuleInNavigatorKey</key>
+				<dict>
+					<key>Split0</key>
+					<dict>
+						<key>PBXProjectModuleGUID</key>
+						<string>E169512B0A6DAD600085C106</string>
+						<key>PBXProjectModuleLabel</key>
+						<string>ICeCoffEETrigger.m</string>
+						<key>_historyCapacity</key>
+						<integer>0</integer>
+						<key>bookmark</key>
+						<string>E169513D0A6DAEBC0085C106</string>
+						<key>history</key>
+						<array>
+							<string>E169512C0A6DAD600085C106</string>
+							<string>E169512D0A6DAD600085C106</string>
+						</array>
+						<key>prevStack</key>
+						<array>
+							<string>E169512E0A6DAD600085C106</string>
+							<string>E169512F0A6DAD600085C106</string>
+						</array>
+					</dict>
+					<key>SplitCount</key>
+					<string>1</string>
+				</dict>
+				<key>StatusBarVisibility</key>
+				<true/>
+			</dict>
+			<key>Geometry</key>
+			<dict>
+				<key>Frame</key>
+				<string>{{0, 20}, {787, 602}}</string>
+				<key>PBXModuleWindowStatusBarHidden2</key>
+				<false/>
+				<key>RubberWindowFrame</key>
+				<string>599 218 787 643 0 0 1920 1178 </string>
+			</dict>
+		</dict>
+		<dict>
+			<key>Content</key>
+			<dict>
+				<key>PBXProjectModuleGUID</key>
+				<string>E16950EE0A6DA5890085C106</string>
+				<key>PBXProjectModuleLabel</key>
+				<string>APEInfo.rtfd</string>
+				<key>PBXSplitModuleInNavigatorKey</key>
+				<dict>
+					<key>Split0</key>
+					<dict>
+						<key>PBXProjectModuleGUID</key>
+						<string>E16950EF0A6DA5890085C106</string>
+						<key>PBXProjectModuleLabel</key>
+						<string>APEInfo.rtfd</string>
+						<key>_historyCapacity</key>
+						<integer>0</integer>
+						<key>bookmark</key>
+						<string>E169513E0A6DAEBC0085C106</string>
+						<key>history</key>
+						<array>
+							<string>E16950E80A6DA57D0085C106</string>
+						</array>
+					</dict>
+					<key>SplitCount</key>
+					<string>1</string>
+				</dict>
+				<key>StatusBarVisibility</key>
+				<true/>
+			</dict>
+			<key>Geometry</key>
+			<dict>
+				<key>Frame</key>
+				<string>{{0, 20}, {754, 705}}</string>
+				<key>PBXModuleWindowStatusBarHidden2</key>
+				<false/>
+				<key>RubberWindowFrame</key>
+				<string>448 117 754 746 0 0 1920 1178 </string>
+			</dict>
+		</dict>
+		<dict>
+			<key>Content</key>
+			<dict>
+				<key>PBXProjectModuleGUID</key>
+				<string>E16950F10A6DA5890085C106</string>
+				<key>PBXProjectModuleLabel</key>
+				<string>ui.plist</string>
+				<key>PBXSplitModuleInNavigatorKey</key>
+				<dict>
+					<key>Split0</key>
+					<dict>
+						<key>PBXProjectModuleGUID</key>
+						<string>E16950F20A6DA5890085C106</string>
+						<key>PBXProjectModuleLabel</key>
+						<string>ui.plist</string>
+						<key>_historyCapacity</key>
+						<integer>0</integer>
+						<key>bookmark</key>
+						<string>E169513F0A6DAEBC0085C106</string>
+						<key>history</key>
+						<array>
+							<string>E16950DD0A6DA4C80085C106</string>
+						</array>
+					</dict>
+					<key>SplitCount</key>
+					<string>1</string>
+				</dict>
+				<key>StatusBarVisibility</key>
+				<true/>
+			</dict>
+			<key>Geometry</key>
+			<dict>
+				<key>Frame</key>
+				<string>{{0, 20}, {733, 961}}</string>
+				<key>PBXModuleWindowStatusBarHidden2</key>
+				<false/>
+				<key>RubberWindowFrame</key>
+				<string>865 137 733 1002 0 0 1920 1178 </string>
+			</dict>
+		</dict>
+		<dict>
+			<key>Content</key>
+			<dict>
+				<key>PBXProjectModuleGUID</key>
+				<string>E16950CC0A6DA00E0085C106</string>
+				<key>PBXProjectModuleLabel</key>
+				<string>APEMain.m</string>
+				<key>PBXSplitModuleInNavigatorKey</key>
+				<dict>
+					<key>Split0</key>
+					<dict>
+						<key>PBXProjectModuleGUID</key>
+						<string>E16950CD0A6DA00E0085C106</string>
+						<key>PBXProjectModuleLabel</key>
+						<string>APEMain.m</string>
+						<key>_historyCapacity</key>
+						<integer>0</integer>
+						<key>bookmark</key>
+						<string>E16951400A6DAEBC0085C106</string>
+						<key>history</key>
+						<array>
+							<string>E16950C80A6DA0070085C106</string>
+						</array>
+					</dict>
+					<key>SplitCount</key>
+					<string>1</string>
+				</dict>
+				<key>StatusBarVisibility</key>
+				<true/>
+			</dict>
+			<key>Geometry</key>
+			<dict>
+				<key>Frame</key>
+				<string>{{0, 20}, {752, 613}}</string>
+				<key>PBXModuleWindowStatusBarHidden2</key>
+				<false/>
+				<key>RubberWindowFrame</key>
+				<string>295 -4 752 654 0 0 1920 1178 </string>
+			</dict>
+		</dict>
+	</array>
 	<key>PerspectiveWidths</key>
 	<array>
@@ -260,12 +467,12 @@
 									<array>
 										<array>
-											<integer>37</integer>
-											<integer>34</integer>
-											<integer>32</integer>
+											<integer>28</integer>
+											<integer>27</integer>
+											<integer>23</integer>
 											<integer>0</integer>
 										</array>
 									</array>
 									<key>PBXSmartGroupTreeModuleOutlineStateVisibleRectKey</key>
-									<string>{{0, 102}, {298, 633}}</string>
+									<string>{{0, 0}, {298, 633}}</string>
 								</dict>
 								<key>PBXTopSmartGroupGIDs</key>
@@ -286,5 +493,5 @@
 								</array>
 								<key>RubberWindowFrame</key>
-								<string>1242 459 315 719 0 0 1600 1178 </string>
+								<string>1547 459 315 719 0 0 1920 1178 </string>
 							</dict>
 							<key>Module</key>
@@ -425,6 +632,6 @@
 			<key>TableOfContents</key>
 			<array>
-				<string>E1BBBF49083858110008E627</string>
-				<string>E1BBBF4A083858110008E627</string>
+				<string>E16950A70A6D9D780085C106</string>
+				<string>E16950A80A6D9D780085C106</string>
 				<string>1C9437FD063B20B00039CFAC</string>
 				<string>1C9437FE063B20B00039CFAC</string>
@@ -450,5 +657,5 @@
 	<true/>
 	<key>ToolbarSizeMode</key>
-	<integer>2</integer>
+	<integer>1</integer>
 	<key>Type</key>
 	<string>Perspectives</string>
@@ -459,9 +666,16 @@
 	<key>WindowOrderList</key>
 	<array>
-		<string>/Users/nicholas/Documents/Development/ICeCoffEE/ICeCoffEE/ICeCoffEE APE.xcode</string>
+		<string>1C530D57069F1CE1000CFCEE</string>
 		<string>E18B4838082F0937000E96F5</string>
+		<string>E16950CC0A6DA00E0085C106</string>
+		<string>E16950F10A6DA5890085C106</string>
+		<string>E16950EE0A6DA5890085C106</string>
+		<string>E169512A0A6DAD600085C106</string>
+		<string>E16950D60A6DA4970085C106</string>
+		<string>/Users/nicholas/Documents/Development/ICeCoffEE/ICeCoffEE/ICeCoffEE.xcodeproj</string>
+		<string>1C530D52069F1CE1000CFCEE</string>
 	</array>
 	<key>WindowString</key>
-	<string>1242 459 315 719 0 0 1600 1178 </string>
+	<string>1547 459 315 719 0 0 1920 1178 </string>
 	<key>WindowTools</key>
 	<array>
@@ -627,7 +841,7 @@
 							<dict>
 								<key>Frame</key>
-								<string>{{0, 0}, {807, 0}}</string>
+								<string>{{0, 0}, {868, 0}}</string>
 								<key>RubberWindowFrame</key>
-								<string>712 119 807 200 0 0 1600 1178 </string>
+								<string>70 488 868 452 0 0 1920 1178 </string>
 							</dict>
 							<key>Module</key>
@@ -641,4 +855,6 @@
 							<key>ContentConfiguration</key>
 							<dict>
+								<key>PBXBuildLogShowsTranscriptDefaultKey</key>
+								<string>{{0, 219}, {868, 208}}</string>
 								<key>PBXProjectModuleGUID</key>
 								<string>XCMainBuildResultsModuleGUID</string>
@@ -653,16 +869,16 @@
 							<dict>
 								<key>Frame</key>
-								<string>{{0, 5}, {807, 175}}</string>
+								<string>{{0, 5}, {868, 427}}</string>
 								<key>RubberWindowFrame</key>
-								<string>712 119 807 200 0 0 1600 1178 </string>
+								<string>70 488 868 452 0 0 1920 1178 </string>
 							</dict>
 							<key>Module</key>
 							<string>PBXBuildResultsModule</string>
 							<key>Proportion</key>
-							<string>175pt</string>
+							<string>427pt</string>
 						</dict>
 					</array>
 					<key>Proportion</key>
-					<string>180pt</string>
+					<string>432pt</string>
 				</dict>
 			</array>
@@ -678,5 +894,5 @@
 			<array>
 				<string>1C530D52069F1CE1000CFCEE</string>
-				<string>E13A4D0C0838534B00845659</string>
+				<string>E16950B50A6D9F860085C106</string>
 				<string>1CD0528F0623707200166675</string>
 				<string>XCMainBuildResultsModuleGUID</string>
@@ -685,5 +901,5 @@
 			<string>xcode.toolbar.config.build</string>
 			<key>WindowString</key>
-			<string>712 119 807 200 0 0 1600 1178 </string>
+			<string>70 488 868 452 0 0 1920 1178 </string>
 			<key>WindowToolGUID</key>
 			<string>1C530D52069F1CE1000CFCEE</string>
@@ -823,5 +1039,5 @@
 										<string>1CDD528C0622207200134675</string>
 										<key>PBXProjectModuleLabel</key>
-										<string>ICeCoffEEWebKit.m</string>
+										<string>APEMain.m</string>
 										<key>StatusBarVisibility</key>
 										<false/>
@@ -832,5 +1048,5 @@
 										<string>{{0, 0}, {854, 208}}</string>
 										<key>RubberWindowFrame</key>
-										<string>106 202 854 724 0 0 1600 1178 </string>
+										<string>151 202 854 724 0 0 1920 1178 </string>
 									</dict>
 									<key>Module</key>
@@ -858,5 +1074,5 @@
 								<string>{{0, 213}, {854, 491}}</string>
 								<key>RubberWindowFrame</key>
-								<string>106 202 854 724 0 0 1600 1178 </string>
+								<string>151 202 854 724 0 0 1920 1178 </string>
 							</dict>
 							<key>Module</key>
@@ -881,11 +1097,11 @@
 			<array>
 				<string>1C530D57069F1CE1000CFCEE</string>
-				<string>E170E048083653E300B484AC</string>
-				<string>E170E049083653E300B484AC</string>
+				<string>E16950C20A6D9FB20085C106</string>
+				<string>E16950C30A6D9FB20085C106</string>
 				<string>1CDD528C0622207200134675</string>
 				<string>1CD0528E0623707200166675</string>
 			</array>
 			<key>WindowString</key>
-			<string>106 202 854 724 0 0 1600 1178 </string>
+			<string>151 202 854 724 0 0 1920 1178 </string>
 			<key>WindowToolGUID</key>
 			<string>1C530D57069F1CE1000CFCEE</string>
@@ -1082,5 +1298,5 @@
 								<string>{{0, 0}, {457, 0}}</string>
 								<key>RubberWindowFrame</key>
-								<string>85 609 457 342 0 0 1600 1178 </string>
+								<string>109 609 457 342 0 0 1920 1178 </string>
 							</dict>
 							<key>Module</key>
@@ -1104,5 +1320,5 @@
 								<string>{{0, 5}, {457, 296}}</string>
 								<key>RubberWindowFrame</key>
-								<string>85 609 457 342 0 0 1600 1178 </string>
+								<string>109 609 457 342 0 0 1920 1178 </string>
 							</dict>
 							<key>Module</key>
@@ -1127,5 +1343,5 @@
 			<array>
 				<string>E18B4838082F0937000E96F5</string>
-				<string>E1BBBF4B083858110008E627</string>
+				<string>E16950A90A6D9D780085C106</string>
 				<string>1C78EAB2065D492600B07095</string>
 				<string>1CD052920623707200166675</string>
@@ -1134,17 +1350,15 @@
 			<string>xcode.toolbar.config.scm</string>
 			<key>WindowString</key>
-			<string>85 609 457 342 0 0 1600 1178 </string>
+			<string>109 609 457 342 0 0 1920 1178 </string>
 			<key>WindowToolGUID</key>
 			<string>E18B4838082F0937000E96F5</string>
 			<key>WindowToolIsVisible</key>
-			<true/>
-		</dict>
-		<dict>
-			<key>FirstTimeWindowDisplayed</key>
-			<false/>
+			<false/>
+		</dict>
+		<dict>
 			<key>Identifier</key>
 			<string>windowTool.breakpoints</string>
 			<key>IsVertical</key>
-			<true/>
+			<false/>
 			<key>Layout</key>
 			<array>
@@ -1157,53 +1371,147 @@
 							<key>ContentConfiguration</key>
 							<dict>
+								<key>PBXBottomSmartGroupGIDs</key>
+								<array>
+									<string>1C77FABC04509CD000000102</string>
+								</array>
 								<key>PBXProjectModuleGUID</key>
-								<string>1CD052930623707200166675</string>
+								<string>1CE0B1FE06471DED0097A5F4</string>
 								<key>PBXProjectModuleLabel</key>
-								<string>Breakpoints</string>
+								<string>Files</string>
+								<key>PBXProjectStructureProvided</key>
+								<string>no</string>
+								<key>PBXSmartGroupTreeModuleColumnData</key>
+								<dict>
+									<key>PBXSmartGroupTreeModuleColumnWidthsKey</key>
+									<array>
+										<real>168</real>
+									</array>
+									<key>PBXSmartGroupTreeModuleColumnsKey_v4</key>
+									<array>
+										<string>MainColumn</string>
+									</array>
+								</dict>
+								<key>PBXSmartGroupTreeModuleOutlineStateKey_v7</key>
+								<dict>
+									<key>PBXSmartGroupTreeModuleOutlineStateExpansionKey</key>
+									<array>
+										<string>1C77FABC04509CD000000102</string>
+									</array>
+									<key>PBXSmartGroupTreeModuleOutlineStateSelectionKey</key>
+									<array>
+										<array>
+											<integer>0</integer>
+										</array>
+									</array>
+									<key>PBXSmartGroupTreeModuleOutlineStateVisibleRectKey</key>
+									<string>{{0, 0}, {168, 350}}</string>
+								</dict>
+								<key>PBXTopSmartGroupGIDs</key>
+								<array/>
+								<key>XCIncludePerspectivesSwitch</key>
+								<false/>
 							</dict>
 							<key>GeometryConfiguration</key>
 							<dict>
-								<key>BreakpointsTreeTableConfiguration</key>
+								<key>Frame</key>
+								<string>{{0, 0}, {185, 368}}</string>
+								<key>GroupTreeTableConfiguration</key>
 								<array>
-									<string>enabledColumn</string>
-									<real>16</real>
-									<string>breakpointColumn</string>
-									<real>216</real>
+									<string>MainColumn</string>
+									<real>168</real>
 								</array>
+								<key>RubberWindowFrame</key>
+								<string>315 424 744 409 0 0 1440 878 </string>
+							</dict>
+							<key>Module</key>
+							<string>PBXSmartGroupTreeModule</string>
+							<key>Proportion</key>
+							<string>185pt</string>
+						</dict>
+						<dict>
+							<key>ContentConfiguration</key>
+							<dict>
+								<key>PBXProjectModuleGUID</key>
+								<string>1CA1AED706398EBD00589147</string>
+								<key>PBXProjectModuleLabel</key>
+								<string>Detail</string>
+							</dict>
+							<key>GeometryConfiguration</key>
+							<dict>
 								<key>Frame</key>
-								<string>{{0, 0}, {240, 195}}</string>
+								<string>{{190, 0}, {554, 368}}</string>
 								<key>RubberWindowFrame</key>
-								<string>135 875 240 216 0 0 1600 1178 </string>
-							</dict>
-							<key>Module</key>
-							<string>PBXDebugBreakpointsModule</string>
+								<string>315 424 744 409 0 0 1440 878 </string>
+							</dict>
+							<key>Module</key>
+							<string>XCDetailModule</string>
 							<key>Proportion</key>
-							<string>195pt</string>
+							<string>554pt</string>
 						</dict>
 					</array>
 					<key>Proportion</key>
-					<string>196pt</string>
+					<string>368pt</string>
 				</dict>
 			</array>
+			<key>MajorVersion</key>
+			<integer>2</integer>
+			<key>MinorVersion</key>
+			<integer>0</integer>
 			<key>Name</key>
 			<string>Breakpoints</string>
 			<key>ServiceClasses</key>
 			<array>
-				<string>PBXDebugBreakpointsModule</string>
+				<string>PBXSmartGroupTreeModule</string>
+				<string>XCDetailModule</string>
 			</array>
 			<key>StatusbarIsVisible</key>
-			<false/>
+			<true/>
 			<key>TableOfContents</key>
 			<array>
-				<string>E170E1BA08366B6E00B484AC</string>
-				<string>E170E1BB08366B6E00B484AC</string>
-				<string>1CD052930623707200166675</string>
-			</array>
+				<string>1CDDB66807F98D9800BB5817</string>
+				<string>1CDDB66907F98D9800BB5817</string>
+				<string>1CE0B1FE06471DED0097A5F4</string>
+				<string>1CA1AED706398EBD00589147</string>
+			</array>
+			<key>ToolbarConfiguration</key>
+			<string>xcode.toolbar.config.breakpoints</string>
 			<key>WindowString</key>
-			<string>135 875 240 216 0 0 1600 1178 </string>
+			<string>315 424 744 409 0 0 1440 878 </string>
 			<key>WindowToolGUID</key>
-			<string>E170E1BA08366B6E00B484AC</string>
+			<string>1CDDB66807F98D9800BB5817</string>
 			<key>WindowToolIsVisible</key>
-			<false/>
+			<true/>
+		</dict>
+		<dict>
+			<key>Identifier</key>
+			<string>windowTool.debugAnimator</string>
+			<key>Layout</key>
+			<array>
+				<dict>
+					<key>Dock</key>
+					<array>
+						<dict>
+							<key>Module</key>
+							<string>PBXNavigatorGroup</string>
+							<key>Proportion</key>
+							<string>100%</string>
+						</dict>
+					</array>
+					<key>Proportion</key>
+					<string>100%</string>
+				</dict>
+			</array>
+			<key>Name</key>
+			<string>Debug Visualizer</string>
+			<key>ServiceClasses</key>
+			<array>
+				<string>PBXNavigatorGroup</string>
+			</array>
+			<key>StatusbarIsVisible</key>
+			<true/>
+			<key>ToolbarConfiguration</key>
+			<string>xcode.toolbar.config.debugAnimator</string>
+			<key>WindowString</key>
+			<string>100 100 700 500 0 0 1280 1002 </string>
 		</dict>
 		<dict>